#include <cstdlib>
#include <iostream>
#include "viies.h"

using namespace std;

/**
* @brief Class for testing
*/
int main (int argc, char* argv[]) {

	// Task 1: swapping
	double a = 1.0, b = -2.0, c = 1.0;
	cout << "A = " << a << ", B = " << b << endl;
	swap_ref<double> (a, b);
	cout << "A = " << a << ", B = " << b << endl;
	swap_ptr<double> (&a, &b);
	cout << "A = " << a << ", B = " << b << endl << endl;
	
	// Task 2: equation
	double solution1 = 0, solution2 = 0;
	if (solve (a, b, c, solution1, solution2)) {
		cout << "Solutions are: " << solution1 << ", " << solution2 << endl;
	} else {
		cout << "There are no solutions in real numbers!" << endl;	
	}
	cout << endl;
	
	// Task 3
	Vector2 p1 (1.0, 2.0); Vector2 p2 (0,0); Vector2 p3 (5.0, 2.0);
	DynamicLine<Vector2> l1 (&p1, &p2);
	DynamicLine<Vector2> l2 = l1;
	l2.p2 = &p3;
	p1.x = 2.0;
	
	// Task 4
	MyArray<int> numbers;
	numbers.addElement (33);
	numbers.addElement (11);
	MyArray<int> copy = numbers;
	copy.addElement (13);
	if (numbers.getSize () != 2 || copy.getSize () != 3)
		cout << "Copy failed - wrong sizes!" << endl;
	if (numbers[0] != copy[0] || numbers[1] != copy[1])
		cout << "Copy failed - wrong elements!" << endl;
	return EXIT_SUCCESS;
}
